****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwinPRO.inc                         #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definition of functions and procedures            #
'#           to access ADwin PRO SYSTEM                        #
'#                                                             #
'#  25.10.1996       creation                                  #
'#  15.01.1997	     Befehle fr den Watchdog eingefhrt       #
'#  08.04.1998  OL   changes for T9/ADSP (ADbasic 3)           #
'#  16.11.2001  JK   comments in English                       #
'#  16.11.2001  JK   SUB_BEGIN/END_CRITICAL_SECTION            #
'#  16.11.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  02.09.2002  MG   T10                                       #
'#  05.10.2002  MF   T10                                       #
'#  17.10.2003  MF   DIGIN 0					                      	 # 
'#  29.09.2004  MF   Bugfix Checkled                           #
'#  03.02.2005  MF   NOT T11																	 #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#else
'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#DEFINE DIO 000h	'DIO - MASK
#DEFINE AD  040h	'A/D - MASK
#DEFINE DA  080h	'D/A - MASK
#DEFINE CPU 0A0h	'CPU - MASK
#DEFINE EXT 0C0h	'EXT - MASK

'---------------------------------------------------------------
' Address-table to access the hardware of the Pro-system,
' depending on the CPU in use (ADSP OR Transputer).
'---------------------------------------------------------------
#IF PROZESSOR = T9 THEN
  #define DL         20400000h
  #define DH         20400010h
  #define DLX        20400020h
  #define DHX        20400030h
  #define ADWR       20400060h
  #define ADRD       20400070h
  #define CPU_EVENT  204000F0h
  #define WATCHDOG   204001D0h
  #define WD_TIMER   204001E0h
  #define CPU_LED    204001F0h
	#define CPU_DIG_ADR 204001B0H 
#ELSE
	#IF PROZESSOR = T10 THEN
  	#define DL         20800000h
	  #define DH         20800010h
  	#define DLX        20800020h
	  #define DHX        20800030h
  	#define ADWR       20800060h
	  #define ADRD       20800070h
  	#define CPU_EVENT  208000F0h
	  #define WATCHDOG   208001D0h
  	#define WD_TIMER   208001E0h
	  #define CPU_LED    208001F0h
		#define CPU_DIG_ADR 208001B0H 
	#ELSE
    #define DL               00h
    #define DH               10h
    #define DLX              20h
    #define DHX              30h
    #define ADWR             60h
    #define ADRD             70h
    #define CPU_EVENT       0F0h
    #define WATCHDOG        1D0h
    #define WD_TIMER        1E0h
    #define CPU_LED         1F0h
	#ENDIF
#ENDIF

'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
SUB poke_nop(adress,value)
#IF PROZESSOR = T9 THEN
   poke(adress,value)
   nops(5)   
#ELSE
	#IF PROZESSOR = T10 THEN
   poke(adress,value)
   nops(10)
  #ELSE
   poke(adress,value)
	#ENDIF
#ENDIF
ENDSUB

'---------------------------------------------------------------
' Procedure which adds one additional NOP-instruction only for
' the ADSP processor, because only necessary there.
'---------------------------------------------------------------
SUB NOP_T9()
  #IF PROZESSOR = T9 THEN
    NOP
  #ENDIF
  #IF PROZESSOR = T10 THEN
    NOP
		NOP
  #ENDIF
ENDSUB


'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
SUB SUB_BEGIN_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

'---------------------------------------------------------------
' calculates address value
'---------------------------------------------------------------
FUNCTION FUNCTIONS_WERT(BEFEHL,KARTE,TYP) AS INTEGER
  FUNCTIONS_WERT = (BEFEHL OR TYP) OR (SHIFT_LEFT(KARTE,8))
ENDFUNCTION

'***************************************************************
'  switches a LED on or off
'  KARTE	:   module-address
'  KARTENTYP: type of module
'  WERT	: 0/1 off/on
'***************************************************************
SUB SETLED(KARTE,KARTENTYP,WERT)
DIM adr as integer
IF (KARTENTYP=cpu) THEN
  POKE(CPU_LED, WERT)
  nop_t9
ELSE
 PRECALC
  adr = FUNCTIONS_WERT( 42, KARTE , KARTENTYP)
  SUB_BEGIN_CRITICAL_SECTION
  poke( ADWR, adr )
  nop_t9
  poke_nop( DLX, WERT)
  SUB_END_CRITICAL_SECTION
ENDIF
ENDSUB


'***************************************************************
'  checks the LED on a module
'  KARTE	:   module-address
'  KARTENTYP: type of module
'***************************************************************
FUNCTION CHECKLED(KARTE,KARTENTYP) AS INTEGER
DIM adr as integer

IF (KARTENTYP=cpu) THEN
  CHECKLED = (PEEK(CPU_LED) and 1)
  nop_t9
ELSE
 PRECALC
  adr = FUNCTIONS_WERT( 42, KARTE , KARTENTYP)
	SUB_BEGIN_CRITICAL_SECTION
  poke_nop( ADRD, adr )
  CHECKLED = peek( DLX) AND 1
	SUB_END_CRITICAL_SECTION
	nop_t9
ENDIF
ENDFUNCTION


'***************************************************************
'  activates or deactivates the external Event input
'  KARTE	:   module-address	   
'  KARTENTYP: type of module
'  WERT	: 0/1 deactivate/activate
'***************************************************************
SUB EVENTENABLE(KARTE,KARTENTYP,WERT)
DIM adr as integer
POKE( cpu_EVENT, 256*WERT)		'enable the EVENT on the processormodule
PRECALC
  adr = FUNCTIONS_WERT( 56, KARTE , KARTENTYP)
	SUB_BEGIN_CRITICAL_SECTION
  poke( ADWR, adr )
  nop_t9
  poke_nop( DLX, 9-WERT)		' EVENT on module 
	SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'  define whether rising/falling edge is triggering the Event
'  (= german:   Event auslsendes Ereignis festlegen)
'  KARTE	:   module-address	   
'  KARTENTYP: type of module
'  WERT	: 0  rising edge              (= steigende Flanke)
'         1  rising edge              (= steigende Flanke)
'         2  falling edge             (= fallende Flanke)
'         3  rising and falling edge  (= beide Flanken)
'***************************************************************
SUB EVENTSOURCE(KARTE,KARTENTYP,WERT)
DIM adr as integer
PRECALC
  adr = FUNCTIONS_WERT( 59, KARTE , KARTENTYP)
	SUB_BEGIN_CRITICAL_SECTION
  poke( ADWR, adr )
  nop_t9
  poke_nop( DLX, WERT)		'EVENTSOURCE on module 
	SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'  activate- or deactivate the Sync-function of a module
'  KARTE	:   module-address	   
'  KARTENTYP: type of module
'  WERT	: 0/1 deactivate/activate
'***************************************************************
SUB SYNCENABLE(KARTE,KARTENTYP,WERT)
DIM adr AS INTEGER
  PRECALC
  adr = FUNCTIONS_WERT( 58, KARTE , KARTENTYP)
	SUB_BEGIN_CRITICAL_SECTION
  poke( ADWR, adr )
  nop_t9
  poke_nop( DLX, WERT)
	SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' latch all those modules, which have been activated with the 
' SYNCENABLE command
'***************************************************************
SUB SYNCALL()
	SUB_BEGIN_CRITICAL_SECTION
  poke( ADWR, 52)
  nop_t9
  poke_nop( DLX, 255)
	SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
'  checks, whether the Sync-function of a module is activated
'  KARTE	:   module-address	   
'  KARTENTYP: type of module
'  result :   0/1   activated/deactivated 
'***************************************************************
FUNCTION SYNCSTAT(KARTE,KARTENTYP) AS INTEGER
DIM adr as integer
  PRECALC
  adr = FUNCTIONS_WERT( 58, KARTE , KARTENTYP)
	SUB_BEGIN_CRITICAL_SECTION
  poke_nop( ADRD, adr )
  SYNCSTAT = peek( DLX) AND 1
	SUB_END_CRITICAL_SECTION
	nop_t9
ENDFUNCTION


'***************************************************************
' commands for processor module 
'***************************************************************

'***************************************************************
' activate watchdog 
'***************************************************************
SUB StartWatchDog()
  poke(watchdog,1)
  nop_t9
ENDSUB

'***************************************************************
' deactivate watchdog
'***************************************************************
SUB StopWatchDog()
  poke(watchdog,0)
  nop_t9
ENDSUB

'***************************************************************
' reset the watchdog timer 
' If the watchdog is activated, the user program has to call  
' this function at least every 80ms.
' For ADSP processor modules produced in year 2000 or later 
' the minimum time interval is 1600 ms.
'***************************************************************
SUB ResetWatchDogTimer()
  poke(WD_TIMER,1)
  nop_t9
ENDSUB

'***************************************************************
'  checks, whether the DIG_IN-function of a CPU module is activated
'  activated = a falling edge has been received 
'  result :   0/1   activated/deactivated 
'***************************************************************
FUNCTION CPU_DIGIN() AS INTEGER
  CPU_DIGIN = peek(cpu_DIG_ADR) AND 1
ENDFUNCTION

#ENDIF
