****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpAD.inc                           #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definition of functions and procedures            #
'#           to access A/D-modules.                            #
'#                                                             #
'#  25.10.1996  OL   creation                                  #
'#  10.06.1999  OL   redesign & comments in english            #
'#  22.11.2000  OL   mux wait time bug (on Transputers)        #
'#                         fixed (ADC + ADC16)                 #
'#                         new subroutine  : ADC_WAIT_MUX()    #
'#  03.12.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  19.12.2001  MF   ADC auto. 14 s MUX on 16 bit RB modules  #
'#  08.04.2002  MF   AIN FX/14                                 #
'#  02.09.2002  MG   T10                                       #
'#  05.10.2002  MF   T10                                       #
'#  10.01.2003  MF   AIN FX/14 :  new :                        #
'#                   BURST_CSTART(), BURST_READ(), SYNC_MODE() #
'#  03.06.2003  MF   AIN 8/14 , AIN 32/14: new:                #
'#  21.04.2004  MF   bugfix BURST_CREAD                        #
'#  01.02.2005  MF   NOT T11                                   #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#  13.12.2005  MF   READ_ADCF4, READ_ADCF8, READ_ADCF?_PACKED #
'#  14.08.2006  MF   POKE_NOP_ADRDF                            #
'#                                                             #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#ELSE
	
'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#DEFINE DIO 000h	'DIO - MASK
#DEFINE AD  040h	'A/D - MASK
#DEFINE DA  080h	'D/A - MASK
#DEFINE CPU 0A0h	'CPU - MASK
#DEFINE EXT 0C0h	'EXT - MASK

'---------------------------------------------------------------
' Address-table to access the hardware of the Pro-system,
' depending on the CPU in use (ADSP OR Transputer).
'---------------------------------------------------------------
#IF PROZESSOR = T9 THEN
  #define DL         20400000h
  #define DH         20400010h
  #define DLX        20400020h
  #define DHX        20400030h
  #define ADWR       20400060h
  #define ADRD       20400070h
  #define adrdf      20400078h
  #define CPU_EVENT  204000F0h
  #define WATCHDOG   204001D0h
  #define WD_TIMER   204001E0h
  #define CPU_LED    204001F0h
  #define d32        20400180h
	#define D32I       20400198H
#ELSE
	#IF PROZESSOR = T10 THEN
		#define DL         20800000h
	  #define DH         20800010h
	  #define DLX        20800020h
	  #define DHX        20800030h
	  #define ADWR       20800060h
	  #define ADRD       20800070h
	  #define adrdf      20800078h
	  #define CPU_EVENT  208000F0h
	  #define WATCHDOG   208001D0h
	  #define WD_TIMER   208001E0h
	  #define CPU_LED    208001F0h
	  #define d32        20800180h
    #define D32I       20800198H
	#ELSE
	  #define DL               00h
	  #define DH               10h
	  #define DLX              20h
	  #define DHX              30h
	  #define ADWR             60h
	  #define ADRD             70h
	  #define CPU_EVENT       0F0h
	  #define WATCHDOG        1D0h
	  #define WD_TIMER        1E0h
	  #define CPU_LED         1F0h
	#endif
#ENDIF


'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
SUB poke_nop(adress,value)
#IF PROZESSOR = T9 THEN
   poke(adress,value)
   nops(5)
#ELSE
	#IF PROZESSOR = T10 THEN
   poke(adress,value)
   nops(10)
	#ELSE
   poke(adress,value)
	#ENDIF
#ENDIF
ENDSUB

'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
SUB poke_nop_ADRDF(adress,value)
#IF PROZESSOR = T9 THEN
   poke(adress,value)
   nops(5)
#ELSE
	#IF PROZESSOR = T10 THEN
   poke(adress,value)
   nop 'required !!!
	 nop
	 nops(9)
	#ELSE
   poke(adress,value)
	#ENDIF
#ENDIF
ENDSUB




'---------------------------------------------------------------
' Procedure which adds one additional NOP-instruction only for
' the ADSP processor, because only neccessary there.
'---------------------------------------------------------------
SUB NOP_T9()
  #IF PROZESSOR = T9 THEN
    NOP
  #ENDIF
  #IF PROZESSOR = T10 THEN
    NOP
		NOP
  #ENDIF
ENDSUB

'---------------------------------------------------------------
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
SUB SUB_BEGIN_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB


'**************************************************************
' Waits for the settling time of the multiplexer.
' waits 14 s for AIN-8/16-RB , AIN-32/16-RB 
' waits 3 s  for all other modules
' This sub is only for T9 or T10 (= ADSP) processors.
'**************************************************************
SUB ADC_WAIT_MUX_T9(card)
DIM addr3 AS LONG
DIM modulcode AS LONG
dim time1,time2,time3 as long
  
	#if prozessor=T9 then
	time1=peek(204003F0H)
  #else
	time1=peek(208003F0H)
	#endif
	
	addr3=069H OR (SHIFT_LEFT(card,8)) 
		
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr3)
  modulcode=PEEK(DLX) AND 255
  SUB_END_CRITICAL_SECTION
  		
						
  IF ((Modulcode=9) OR (Modulcode=11)) then 'AIN 8/16 RB or AIN 32/16RB
		time3=560 '14 s
	ELSE
		   IF ((Modulcode=21) or (modulcode=23)) then 'AIN 8/14 or 'AIN 32/14
			   time3=100 '2,5 s
		 	 ELSE
           IF ((Modulcode=22) or (Modulcode=24)) then 'AIN 8/16 RC or 'AIN 32/16 RC
						time3=220 '5,5 s
					 ELSE
						time3=120 '3 s 
					 ENDIF
			 ENDIF			 	 
	ENDIF	

 	#if prozessor=T9 then
	do
	time2=peek(204003F0H)-time1+10
	until (time2>time3)
	
	#else
	do
	time2=peek(208003F0H)-time1+5
	until (time2>time3)
	#endif
 
ENDSUB


'***************************************************************
' Waits for the settling time of the multiplexer.
' This procedure is suitable for the ADC and the ADC16 function. 
' (Rechecked by JK 22.11.2000 :  The waiting time caused by this
'  procedure is 2.7 microseconds (for T8 processor with 25MHz), 
'  which is also sufficient for Pro-AIn-8/16) 
' For AIN-8/16-RB or AIN-32/16-RB please use ADC_WAIT_MUX_T9 .
'***************************************************************
SUB ADC_WAIT_MUX()
  ' Inline assembly code has to be written in lowercase letters !
  #IF PROZESSOR = T5 THEN
    ASM{
	ldc 5
	ldc 3
	div
	stl 0
	ldc 5
	ldc 3
	div
	stl 0
	ldc 5
	ldc 3
	div
	stl 0
	ldc 5
	ldc 3
	div
	stl 0
    }END_ASM
  #ELSE
    #IF PROZESSOR = T9 THEN
      SLEEP(30)
    #ELSE
    	#IF PROZESSOR = T10 THEN
      	SLEEP(30)
    	#ELSE

      ASM{
	ldc 2
	ldc 1
	div
	stl 0
	ldc 4
	ldc 12
	shl
	stl 0
      }END_ASM
			
			#ENDIF
    #ENDIF
  #ENDIF
ENDSUB


'***************************************************************
' Samples, converts and reads out the digital ADC-value of an
' analog input.
' This function is suitable for all 12 bit modules and for the
' following 16 bit modules :  AIN-8/16-RB , AIN-32/16-RB 
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' ! Attention:                                                 !
' ! This instruction is not prepared to handle an access from  !
' ! a low AND high priority process to the same module.        !
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' card:   module-address
' ADC_No: channel number of analog input
' result: 16 bit integer
'***************************************************************
FUNCTION ADC(card,ADC_No) AS INTEGER
  DIM addr, addr1, adc_n, reminder AS INTEGER
	
  '............ set MUX ............
  PRECALC
  addr = 050h OR (SHIFT_LEFT(card,8))
  PRECALC
  adc_n = ADC_No-1
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n)
  SUB_END_CRITICAL_SECTION
  '............ wait multiplexer settling time ........
  #IF PROZESSOR=ADSP THEN 
    ADC_WAIT_MUX_T9(card) ' wait 3 s or more, depending on hardware
  #ELSE
	  ADC_WAIT_MUX          ' wait 3 s 
  #ENDIF
  '............ start conversion ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  SUB_END_CRITICAL_SECTION
  '............ wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(card,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
  '............ read out result ............
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr1)
  ADC = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Samples, converts and reads out the digital 16 bit ADC-value
' of an analog input.
' For AIN-8/16-RB or AIN-32/16-RB please use the function "ADC"
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' ! Attention:                                                 !
' ! This instruction is not prepared to handle an access from  !
' ! a low AND high priority process to the same module.        !
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' card:   module-address
' ADC_No: channel number of analog input
' result: 16 bit integer
'***************************************************************
FUNCTION ADC16(card,ADC_No) AS INTEGER
  DIM addr, addr1, adc_n, reminder AS INTEGER
  '************ set MUX ************
  PRECALC
  addr = 050h OR (SHIFT_LEFT(card,8))
  PRECALC
  adc_n = ADC_No - 1
  SUB_BEGIN_CRITICAL_SECTION
  POKE (ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n)
  SUB_END_CRITICAL_SECTION
  '............ wait multiplexer settling time ........
  ADC_WAIT_MUX
  '............ start conversion ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX, 0)
  SUB_END_CRITICAL_SECTION
  '............ wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(card,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
  '............ start conversion again (serial ADC) ............
  PRECALC
  addr = 054h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  SUB_END_CRITICAL_SECTION
  '............ wait EOC ............
  PRECALC
  addr = 056h OR (SHIFT_LEFT(card,8))
  PRECALC
  addr1 = AD OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND 1)
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
  '............ read out result ............
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr1)
  ADC16 = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Set MUX to desired input channel.
' (Gain is only on 12 bit modules available!)
' card:   module-address
' select: bit 6 & 5 -> gain,  bit 4...0 -> channel 1...32
'***************************************************************
SUB SET_MUX(card,select)
  DIM addr, adc_n AS INTEGER
  PRECALC
  addr = 050h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,select)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Start conversion of ADC.
' card: module-address
'***************************************************************
SUB START_CONV(card)
  DIM addr, adc_n AS INTEGER
  PRECALC
  addr = 054h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Wait until EOC-signal goes active (End Of Conversion).
' card: module-address
'***************************************************************
SUB WAIT_EOC(card)
  DIM addr, reminder AS INTEGER
  PRECALC
  addr = 056h OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = PEEK(DLX) AND 1
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
ENDSUB


'***************************************************************
' Returns conversion result of ADC.
' card:   module-address
' result: 16 bit integer
'***************************************************************
FUNCTION READADC(card) AS INTEGER
DIM addr AS INTEGER
  PRECALC
  addr = AD OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADC = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Returns conversion result of ADC and starts immediately
' a new conversion.
' card:   module-address
' result: 16 bit integer
'***************************************************************
FUNCTION READADC_SCONV(card) AS INTEGER
  DIM addr AS INTEGER
  PRECALC
  addr = 058h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADC_SCONV = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Selects single-ended (s.e.) or differential (diff.) inputs
' for the AIN-32/12-module only.
' card: module-address
' mode: s.e. -> 0,  diff. -> 1 (default after power-up)
'***************************************************************
SUB SE_DIFF(card,mode)
  DIM addr AS INTEGER
  PRECALC
  addr = 061h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,mode)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Samples, converts and reads out the digital 16 bit ADC-value
' of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' ! Attention:                                                 !
' ! This instruction is not prepared to handle an access from  !
' ! a low AND high priority process to the same module.        !
' !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
' card :  module-address
' ADC_No: channel number of analog input
' result: 16 bit integer
'***************************************************************
FUNCTION ADCF(card,ADC_No) AS INTEGER
  DIM addr, addr1, dip, adc_n1, adc_n, reminder AS INTEGER
  PRECALC
  dip = SHIFT_LEFT(card,8)
  PRECALC
  adc_n = ADC_No-1
  PRECALC
  adc_n1 = SHIFT_LEFT(1,adc_n)
  '............ start conversion ............
  PRECALC
  addr = 054h OR dip
  SUB_BEGIN_CRITICAL_SECTION
  POKE (ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,adc_n1)
  SUB_END_CRITICAL_SECTION
  '............ wait EOC ............
  PRECALC
  addr = 056h OR dip
  PRECALC
  addr1 = (AD+adc_n) OR dip
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = PEEK(DLX) AND adc_n1
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
  '............ read out result ............
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD, addr1)
  ADCF = PEEK(DLX) 
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Starts a conversion on selected ADC on AIN-Fx/yy-modules.
' card:   module-address
' select: Datenbit z. B.: 0101=adc1+3
'***************************************************************
SUB START_CONVF(card,select)
  DIM addr,adc_n AS INTEGER
  PRECALC
  addr = 054h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,select)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Wait until EOC-signals of all selected ADCs are active.
' (for AIN-Fx/yy-modules only)
' card:   module-address
' select: ADC-#1 -> bit 0,  ...,  ADC-#8 -> bit 7
'***************************************************************
SUB WAIT_EOCF(card,select)
  DIM addr, reminder AS INTEGER
  PRECALC
  addr = 056h OR (SHIFT_LEFT(card,8))
  DO
    SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
    reminder = (PEEK(DLX) AND select)
    SUB_END_CRITICAL_SECTION
  UNTIL(reminder = 0)
ENDSUB


'***************************************************************
' Returns conversion result of ADC of AIN-Fx/yy-module.
' card:   module-address
' ADC_No: channel number of analog input
' result: 16 bit integer
'***************************************************************
FUNCTION READADCF(card,ADC_No) AS INTEGER
  DIM addr AS INTEGER
  PRECALC
  addr = (03Fh+ADC_No) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADCF = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Returns conversion result of two ADC's simultaneously from
' an AIN-Fx/yy-module.
' card:   module-address
' ADC_No: channel number of analog input
' result: 32 bit integer
'         low-word -> ADC_No,  high-word -> ADC_No + 1
'***************************************************************
FUNCTION READADCF_32(card,ADC_No) AS INTEGER
  DIM addr AS INTEGER
  PRECALC
  addr = (03Fh+ADC_No) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADCF_32 = SHIFT_LEFT(PEEK(DH),16)
  READADCF_32 = READADCF_32 OR PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Returns conversion result of two ADC's simultaneously and
' immediately starts the conversion of both ADC again.
' card:   module-address
' ADC_No:	1 = channel no. 1 + 2
' 		2 = channel no. 3 + 4
' 		3 = channel no. 5 + 6
'		4 = channel no. 7 + 8
' result: 32 bit integer
'         low-word -> ADC_No,  high-word -> ADC_No + 1
'***************************************************************
FUNCTION READADCF_SCONV_32(card,ADC_No) AS INTEGER
  DIM addr AS INTEGER
  PRECALC
  addr = (049h+ADC_No) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADCF_SCONV_32 = SHIFT_LEFT(PEEK(DH),16)
  READADCF_SCONV_32 = (READADCF_SCONV_32 OR PEEK(DLX))
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Returns conversion result of ADC and starts immediately
' a new conversion (for AIN-Fx/yy-modules only).
' card:   module-address
' ADC_No: channel number of analog input
' result: 16 bit integer
'***************************************************************
FUNCTION READADCF_SCONV(card,ADC_No) AS INTEGER
  DIM addr AS INTEGER
  PRECALC
  addr = (057h+ADC_No) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  Poke_NOP(ADRD,addr)
  READADCF_SCONV = PEEK(DLX)
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'***************************************************************
' Sets, if equipped with a S&H add-on PCB,
' the mode of the S&H stage.
' card: module-address
' mode: sample -> 0,  hold -> 1
'***************************************************************
SUB SH_SETMODE(card,mode)
  DIM addr AS INTEGER
  PRECALC
  addr = 05Ah OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,mode)
  SUB_END_CRITICAL_SECTION
ENDSUB



'**************************************************************
'Sub is setting the parameters of the burst mode
'card : dip switch address
'mode=1 Sample Channel 1 only
'mode=2 Sample Channel 1-2
'mode=3 Sample Channel 1-4
'mode=4 Sample Channel 1-8 
'sampleperiode (n*25 ns)
'samples max 2^19 values in Mode 1
'This sub is only for ADSP processors and Fx/14
'**************************************************************
SUB BURST_INIT(card,mode,sampleperiode,samples)
DIM addr AS INTEGER
DIM mode2 AS INTEGER

  ADDR=(SHIFT_LEFT(card,8)) OR 51H
	
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,addr)
    NOP_T9
    Poke_NOP(d32,sampleperiode)
  SUB_END_CRITICAL_SECTION

  inc ADDR       'samples
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,addr)
    NOP_T9
    Poke_NOP(d32,samples)
  SUB_END_CRITICAL_SECTION

  ADDR=ADDR + 2       'set mode
  MODE2=SHIFT_LEFT(((mode-1) AND 3),8)

  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADDR)
    NOP_T9
    Poke_NOP(DLX,MODE2)
  SUB_END_CRITICAL_SECTION
endsub

'**************************************************************
'Sub start the burst measurement
'card : dip switch address
'This sub is only for ADSP processors and Fx/14
'**************************************************************
SUB BURST_START(card)
  DIM ADR AS LONG
  DIM MODE AS LONG
  
  ADR=054h OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION  
    poke_nop(ADRD,ADR)
    MODE=PEEK(D32)OR 10000000000B
  SUB_END_CRITICAL_SECTION

  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,MODE)
  SUB_END_CRITICAL_SECTION

ENDSUB


'**************************************************************
'Sub start the burst measurement in continous mode
'card : dip switch address
'This sub is only for ADSP processors and Fx/14 Rev B2 
'**************************************************************
SUB BURST_CSTART(card) 
  DIM ADR AS LONG
  DIM MODE AS LONG
  
  ADR=054h OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION  
    poke_nop(ADRD,ADR)
    MODE=PEEK(D32)OR 110000000000B
  SUB_END_CRITICAL_SECTION

  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADR)
    NOP_T9
    Poke_NOP(D32,MODE)
  SUB_END_CRITICAL_SECTION
ENDSUB





'**************************************************************
'function reads the progress of the burst measure
'return value: number of convertions to do
'card : dip switch address
'This function is only for ADSP processors and Fx/14
'**************************************************************

function BURST_STATUS(card) AS INTEGER
  DIM ADDR AS INTEGER
  DIM COUNT AS LONG
   
  ADDR = 052h OR (SHIFT_LEFT(card,8))
	 
   SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP(ADRD,addr)
      COUNT = peek(d32)      
   SUB_END_CRITICAL_SECTION
   
  INC ADDR
   
   SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop(ADRD,addr)
      BURST_STATUS=count-peek(d32)
   SUB_END_CRITICAL_SECTION	

endfunction

'**************************************************************
'transfer the input data to an array
'card : dip switch address
'channel: select channel
'startadr: first value of channel which should be transferred
'length: number of values
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for ADSP processors and Fx/14
'**************************************************************
SUB BURST_READ(card,channel,startadr,length,array,array_startindex)

DIM ADR AS LONG
DIM ADDR AS LONG
DIM value AS LONG
DIM i AS LONG
dim mode as long
dim ramstartadr as long
dim lenint as long
dim pointer as long

 ADR=SHIFT_LEFT(card,8) 
 
 addr=054H or adr
 SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP(ADRD,addr)
      MODE=peek(DLX) AND 1100000000B
 SUB_END_CRITICAL_SECTION	
  
 RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
 		
 addr=061H or adr
 SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,addr)
      nop_t9
      poke_nop(d32,RAMSTARTADR)
 SUB_END_CRITICAL_SECTION	

 addr=60H or adr
 
 lenint=LENGTH AND 0FFFFFFFEH
 
 if (LENINT>1) then
   for i=1 to LENINT step 2   
    SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop(ADRD,addr)
      value=peek(d32)
    SUB_END_CRITICAL_SECTION
    pointer=array_startindex+i-1	
    array[pointer]=value AND 0FFFFH
    array[pointer+1]=SHIFT_RIGHT(VALUE,16)	
   NEXT
 endif
 
 if (LENGTH AND 1=1) THEN
    SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop(ADRD,addr)
      array[LENGTH+array_startindex-1]=peek(d32) AND 0FFFFH
    SUB_END_CRITICAL_SECTION	
 endif

ENDSUB


'**************************************************************
'transfer the input data to an array
'card : dip switch address
'channel: select channel
'length: number of values
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for ADSP processors and Fx/14
'**************************************************************
SUB BURST_CREAD(card,channel,length,array[],array_startindex)

 DIM adr as long
 dim diff as long
 dim pos as long 
 dim le as long 
 dim addr as long
 dim anz as long
 dim i as long
 dim str[2] as long
 dim len[2] as long
 dim sindex[2] as long

 ADR=SHIFT_LEFT(card,8) 

 
 addr=052H or adr
 SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP(ADRD,addr)
      le=peek(D32) 
 SUB_END_CRITICAL_SECTION	

 inc addr

 SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP(ADRD,addr)
      pos=peek(D32) 
 SUB_END_CRITICAL_SECTION	

 diff=pos-length


 if (diff>=0) then 'overflow ?
  anz=1
	str[1]= diff
	len[1]=length
	sindex[1]=array_startindex
 else
	anz=2
	str[1]=le+diff
	str[2]=1
	len[1]=-diff
	len[2]=pos
	sindex[1]=array_startindex
	sindex[2]=array_startindex-diff
 endif


 for i=1 to anz
  burst_read(card,channel,str[i],len[i],array,sindex[i])
 next

endsub


'**************************************************************
'transfer the input data to an array
'card : dip switch address
'channel: select channel
'startadr: first value of channel which should be transferred
'length: number of values / 2
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for ADSP processors and Fx/14
'**************************************************************
SUB BURST_READ_PACKED(card,channel,startadr,length,array,array_startindex)

DIM ADR AS LONG
DIM ADDR AS LONG
DIM VALUE AS LONG
DIM I AS LONG
DIM MODE AS LONG
DIM RAMSTARTADR as long
DIM LENINT AS LONG
DIM POINTER AS LONG
DIM INTERNAINDEX AS LONG

 ADR=SHIFT_LEFT(card,8) 
 INTERNAINDEX=ARRAY_STARTINDEX-1
 
 addr=054H or adr
 SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP(ADRD,addr)
      MODE=peek(DLX) AND 1100000000B
 SUB_END_CRITICAL_SECTION	
  
 RAMSTARTADR=(SHIFT_LEFT((channel-1),(20-shift_right(mode,8))))+startadr-1
 	 
 ADDR=061H OR ADR
 SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,ADDR)
      nop_t9
      poke_nop(d32,RAMSTARTADR)
 SUB_END_CRITICAL_SECTION	
 
 ADDR=060H or ADR
  
 IF (LENGTH>0) THEN                             
 	FOR i=1 to LENGTH    
    SUB_BEGIN_CRITICAL_SECTION 
      poke_nop(ADRD,addr)
      array[i+INTERNAINDEX]=peek(d32)
    SUB_END_CRITICAL_SECTION	
 	NEXT
 ENDIF
 	 
ENDSUB



'**************************************************************
'Function stop the burst measure and returns the samples  
'card : dip switch address
'This sub is only for ADSP processors and Fx/14
'**************************************************************
Function BURST_ABORT(card) AS INTEGER

DIM ADDR AS LONG
DIM value AS LONG

 addr=054H OR (SHIFT_LEFT(card,8)) 
	  
 SUB_BEGIN_CRITICAL_SECTION 
      poke_NOP(ADRD,addr)
      Value=peek(d32) AND 0FFFFFBFFH
 SUB_END_CRITICAL_SECTION	

 SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,addr)
      nop_t9
      poke_nop(d32,value)
 SUB_END_CRITICAL_SECTION	

 dec addr
  
 SUB_BEGIN_CRITICAL_SECTION 'wert
      poke_nop(ADRD,addr)
      BURST_ABORT=peek(d32)
 SUB_END_CRITICAL_SECTION	
 nop_t9
ENDFUNCTION


'***************************************************************
'sub set the input range 
'card: dip switch address
'channel 1-8
'mode=0 range -10 V -> +10 V
'mode=1 range -5V   -> + 5 V
'mode=2 range -2.5V -> + 2.5 V
'mode=3 range -1.25 -> + 1.25 V
'for AIN Fx/14 only 
'***************************************************************
SUB SET_GAIN(card,channel,mode)
  DIM addr, AS INTEGER
  DIM mode3 AS INTEGER
  DIM shift AS INTEGER
		
  addr = 055h OR (SHIFT_LEFT(card,8))
  shift=shift_left((channel-1),1)
	
  SUB_BEGIN_CRITICAL_SECTION
    Poke_NOP(ADRD,addr)
   	mode3 = PEEK(DLX) 
  SUB_END_CRITICAL_SECTION
  
  mode3=(mode3 AND NOT (shift_left(3,shift))) OR (shift_left((mode),shift))  
		 
  SUB_BEGIN_CRITICAL_SECTION
     POKE(ADWR,addr)
     NOP_T9
     Poke_NOP(DLX,mode3)
  SUB_END_CRITICAL_SECTION

ENDSUB

'**************************************************************
'initialising the syncronisation mode of the f14 board
'card : dip switch address
'mode =0 normal Mode (no syncronasation)
'     =1 Master Mode
'     =2 Slave Mode
'     =3 Event Mode
'**************************************************************
SUB SYNC_MODE(card,MODE)

dim addr as long

  addr = 04Fh OR (SHIFT_LEFT(card,8))
  
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADDR)
    NOP_T9
    Poke_NOP(D32,MODE)
  SUB_END_CRITICAL_SECTION

ENDSUB

'**************************************************************
'card : dip switch address
'time 0=default time
'     1-2048 time in 25 ns
'**************************************************************
SUB SEQ_SET_DELAY(card,time)

dim addr as long

  addr = 63H OR (SHIFT_LEFT(card,8))
  
  SUB_BEGIN_CRITICAL_SECTION  
    POKE(ADWR,ADDR)
    NOP_T9
    Poke_NOP(D32,time)
  SUB_END_CRITICAL_SECTION

ENDSUB

'**************************************************************
'initialising the ain mode 
'card : dip switch address
'mode =0 normal Mode 
'     =1 single shot mode
'     =3 continuous mode
'gain=0 range -10 V -> +10 V
'gain=1 range -5V   -> + 5 V
'gain=2 range -2.5V -> + 2.5 V
'gain=3 range -1.25 -> + 1.25 V

'**************************************************************

SUB SEQ_MODE(CARD,MODE,GAIN)

dim addr as long
   addr=52h or (SHIFT_LEFT(card,8))
   SUB_BEGIN_CRITICAL_SECTION  
	 POKE(ADWR,ADDR)
	 NOP_T9
   POKE_NOP(DLX,0)
   SUB_END_CRITICAL_SECTION
  
	 SUB_BEGIN_CRITICAL_SECTION
   POKE(ADWR,addr-2)
   NOP_T9
   Poke_NOP(DLX,shift_left(GAIN,5))
   SUB_END_CRITICAL_SECTION
	 
	 SUB_BEGIN_CRITICAL_SECTION
	 POKE(ADWR,ADDR)
	 NOP_T9
   POKE_NOP(DLX,MODE)
   SUB_END_CRITICAL_SECTION
	 
ENDSUB


'**************************************************************
'select the channel in single shot or continuous mode 
'card : dip switch address
'channel :selected channels in binary
'**************************************************************
SUB SEQ_SELECT(card,Channel)
dim addr as long
   addr=53h or (SHIFT_LEFT(card,8))
   SUB_BEGIN_CRITICAL_SECTION  
	 POKE(ADWR,ADDR)
	 NOP_T9
   POKE_NOP(D32,CHANNEL)
   SUB_END_CRITICAL_SECTION
	 nop_t9
ENDSUB

'**************************************************************
'this function returns the number of channel that is in progress
'card : dip switch address
'This sub is only for (ADSP) processors 
'**************************************************************

function SEQ_STATUS(card) AS INTEGER
  DIM ADDR AS INTEGER
     
  ADDR = 051h OR (SHIFT_LEFT(card,8))
	 
   SUB_BEGIN_CRITICAL_SECTION
      Poke_NOP(ADRD,addr)
      SEQ_STATUS = peek(d32)      
   SUB_END_CRITICAL_SECTION
   nop_t9
endfunction

'**************************************************************
'transfer the input data to an array
'card : dip switch address
'channel:
'This sub is only for (ADSP) processors 
'**************************************************************

FUNCTION SEQ_READ_ONE(card,channel) as long 
	 
   dim value as long
   dim i as long
	 dim baseadr as long
	 
	 i=shift_right(channel-1,1)
	 
	 baseadr=(040h+i) OR (SHIFT_LEFT(card,8))
    
   SUB_BEGIN_CRITICAL_SECTION
	 Poke_NOP(ADRD,baseadr)
	 if (channel and 1=1) then 
		SEQ_READ_ONE=PEEK(d32) AND 0FFFFH    
   else
	  SEQ_READ_ONE=shift_right(PEEK(d32),16) 
	 endif
   SUB_END_CRITICAL_SECTION
	 nop_t9

endfunction

'**************************************************************
'transfer the input data to an array
'card : dip switch address
'channel:
'This sub is only for (ADSP) processors 
'**************************************************************

FUNCTION SEQ_READ_TWO(card,channel) as long 
	 
   dim value as long
	 dim baseadr as long
	 
	 baseadr=(040h+channel) OR (SHIFT_LEFT(card,8))
    
   SUB_BEGIN_CRITICAL_SECTION
	 Poke_NOP(ADRD,baseadr)
	 SEQ_READ_TWO=PEEK(D32)
   SUB_END_CRITICAL_SECTION
	 nop_t9
				   
endfunction

'**************************************************************
'transfer the input data to an array
'card : dip switch address
'length: number of values
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for (ADSP) processors 
'**************************************************************

SUB SEQ_READ(card,length,array[],array_startindex)  
	 
   dim value as long
   dim i as long
	 dim baseadr as long
	
	 baseadr=(040h) OR (SHIFT_LEFT(card,8))
    
   if (length>2) then 
      for i=1 to length-2 step 2
         SUB_BEGIN_CRITICAL_SECTION
				 Poke_NOP(ADRD,baseadr)
				 Value=PEEK(D32)
         SUB_END_CRITICAL_SECTION
				 inc baseadr
				 array[i+array_startindex-1]=value AND 0FFFFH   'Kanal 1
         array[i+array_startindex]=shift_right(value,16) 'Kanal 2	
       next  	
    endif
   
	 SUB_BEGIN_CRITICAL_SECTION
   Poke_NOP(ADRD,baseadr)
   Value=PEEK(D32)
   SUB_END_CRITICAL_SECTION
   
   if (length and 1=1) then 
     array[length+array_startindex-1]=value AND 0FFFFH   
   else 
     array[length+array_startindex-2]=value AND 0FFFFH   
     array[length+array_startindex-1]=shift_right(value,16) 
   endif
	 
endsub	



'**************************************************************
'transfer the input data to an array
'card : dip switch address
'length: number of values / 2
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for(ADSP) processors 
'**************************************************************

SUB SEQ_READ_PACKED(card,length,array[],array_startindex)  
	 
   dim i as long
   
   for i=1 to length
    SUB_BEGIN_CRITICAL_SECTION
	  Poke_NOP(ADRD,(03Fh+i) OR (SHIFT_LEFT(card,8)))
    array[i+array_startindex-1]=Peek(D32)      
	  SUB_END_CRITICAL_SECTION  
   next  	  
   
endsub	

'**************************************************************
'transfer the input data of all 32 channels to an array
'card : dip switch address
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for (ADSP) processors 
'**************************************************************

SUB SEQ_READ32(card,array[],array_startindex)  
   dim value as long
	 
   SUB_BEGIN_CRITICAL_SECTION
   Poke_nop(ADRD,(040h)OR (SHIFT_LEFT(card,8)))
   
	 #if prozessor=t9 then
	 nops(7)
	 #else	 
	 nops(14)
   #endif
	 
	 
	 Value=PEEK(D32i)	 
	 array[array_startindex]=value AND 0FFFFH   
   array[1+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[4+array_startindex]=value AND 0FFFFH   
	 array[5+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[8+array_startindex]=value AND 0FFFFH   
   array[9+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[12+array_startindex]=value AND 0FFFFH   
   array[13+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[16+array_startindex]=value AND 0FFFFH   
   array[17+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[20+array_startindex]=value AND 0FFFFH   
   array[21+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[24+array_startindex]=value AND 0FFFFH   
   array[25+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[28+array_startindex]=value AND 0FFFFH   
   array[29+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[2+array_startindex]=value AND 0FFFFH   
   array[3+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[6+array_startindex]=value AND 0FFFFH   
   array[7+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[10+array_startindex]=value AND 0FFFFH   
   array[11+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[14+array_startindex]=value AND 0FFFFH   
   array[15+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[18+array_startindex]=value AND 0FFFFH   
   array[19+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32i)
   array[22+array_startindex]=value AND 0FFFFH   
   array[23+array_startindex]=shift_left(value,-16) 
   Value=PEEK(D32i)
   array[26+array_startindex]=value AND 0FFFFH   
   array[27+array_startindex]=shift_left(value,-16) 
	 Value=PEEK(D32)
   array[30+array_startindex]=value AND 0FFFFH   
   array[31+array_startindex]=shift_left(value,-16) 
   SUB_END_CRITICAL_SECTION
endsub	  


'**************************************************************
'transfer the input data of all 32 channels to an array
'card : dip switch address
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for (ADSP) processors 
'**************************************************************

SUB SEQ_READ32_PACKED(card,array[],array_startindex)  
   dim value as long
   SUB_BEGIN_CRITICAL_SECTION
   Poke_NOP(ADRD,(040h) OR (SHIFT_LEFT(card,8)))
   nop_t9
	 nop_t9
	 array[array_startindex]=PEEK(D32i)
	 nop_t9
   nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 array[2+array_startindex]=PEEK(D32i)
	 nop_t9 
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 array[4+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[6+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[8+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[10+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[12+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[14+array_startindex]=PEEK(D32i)
	 nop_t9
   nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[1+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[3+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[5+array_startindex]=PEEK(D32i) 
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[7+array_startindex]=PEEK(D32i) 
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 array[9+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[11+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
   array[13+array_startindex]=PEEK(D32i)
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 nop_t9
	 array[15+array_startindex]=PEEK(D32)
   nop_t9
   SUB_END_CRITICAL_SECTION
endsub	

'**************************************************************
'transfer the input data from channel 1-4 to an array
'card : dip switch address
'array: destination array 
'index: startindex in the destination array
'**************************************************************

SUB READ_ADCF4_PACKED(card,array[],index)    
SUB_BEGIN_CRITICAL_SECTION
	Poke_nop_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
	array[index]=PEEK(D32i)
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	array[index+1]=PEEK(D32)
	nop_t9
SUB_END_CRITICAL_SECTION
ENDSUB

'**************************************************************
'transfer the input data from channel 1-8 to an array
'card : dip switch address
'array: destination array 
'index: startindex in the destination array
'**************************************************************

SUB READ_ADCF8_PACKED(card,array[],index)    
SUB_BEGIN_CRITICAL_SECTION
	Poke_nop_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
	array[index]=PEEK(D32i)
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	array[index+1]=PEEK(D32i)	
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	array[index+2]=PEEK(D32i)
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	nop_t9
	array[index+3]=PEEK(D32)
SUB_END_CRITICAL_SECTION
  nop_t9
ENDSUB

'**************************************************************
'transfer the input data from channel 1-8 to an array
'card : dip switch address
'array: destination array 
'index: startindex in the destination array
'**************************************************************

SUB READ_ADCF8(card,array[],index)    
dim value as long

SUB_BEGIN_CRITICAL_SECTION
	Poke_nop_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
	
	value=PEEK(D32i)'channel 1 + 2
	array[index]=value AND 0FFFFH
	array[index+1]=shift_right(value,16)
	
	value=PEEK(D32i)'channel 3 + 4
	array[index+2]=value AND 0FFFFH
	array[index+3]=shift_right(value,16)

	value=PEEK(D32i)'channel 5 + 6
	array[index+4]=value AND 0FFFFH
	array[index+5]=shift_right(value,16)
  
	value=PEEK(D32)'channel 7 + 8
	SUB_END_CRITICAL_SECTION
	
	array[index+6]=value AND 0FFFFH
	array[index+7]=shift_right(value,16)

ENDSUB


'**************************************************************
'transfer the input data from channel 1-4 to an array
'card : dip switch address
'array: destination array 
'index: startindex in the destination array
'**************************************************************
SUB READ_ADCF4(card,array[],index)    
dim value as long

  SUB_BEGIN_CRITICAL_SECTION
	Poke_nop_adrdf(ADRDF,(040h) OR (SHIFT_LEFT(card,8)))
	value=PEEK(D32i)'channel 1 + 2
	array[index]=value AND 0FFFFH
	array[index+1]=shift_right(value,16)
	value=PEEK(D32)'channel 3 + 4
  SUB_END_CRITICAL_SECTION
	array[index+2]=value AND 0FFFFH
	array[index+3]=shift_right(value,16)
ENDSUB



#endif

