****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--INC--PRO
'
'###############################################################
'#                        ADwpDA.inc                           #
'#              INCLUDE-file for ADwin-Pro-system              #
'###############################################################
'#                                                             #
'# Contents: Definitions of functions and procedures           #
'#           to access D/A-modules.                            #
'#                                                             #
'#  25.10.1996  OL   creation                                  #
'#  10.06.1999  OL   redesign & comments in english            #
'#  03.12.2001  JK   1st line : ADBASIC-SYSTEM_FILE...         #
'#  02.09.2002  MG   T10                                       #
'#  05.10.2002  MF   T10                                       #
'#  27.01.2004 MF/TN new commands for memory option            #
'#                   (e.g. Pro-Aout-4/16-M2)                   #
'#  03.02.2005  MF    NOT T11                                  #
'#  14.04.2005  MF   ERROR WRONG PROCESSOR                     #
'#  23.01.2006  MF   WRITEDAC32                                #
'# Attention:                                                  #
'#   - Do not copy the first source line (containing           #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !              #
'#     Otherwise the Syntax color may be not correct.          #
'#   - This includefile requires ADbasic 4.0 or higher!        #
'#                                                             #
'###############################################################

#IF PROZESSOR=T11 THEN
#error("This include file can only be used with the processor T2, T4, T5, T8, T9 or T10.")
#ELSE

'---------------------------------------------------------------
' Base-address for the different types of Pro-modules.
'---------------------------------------------------------------
#DEFINE DIO 000h	'DIO - MASK
#DEFINE AD  040h	'A/D - MASK
#DEFINE DA  080h	'D/A - MASK
#DEFINE CPU 0A0h	'CPU - MASK
#DEFINE EXT 0C0h	'EXT - MASK

'---------------------------------------------------------------
' Address-table to access the hardware of the Pro-system,
' depending on the CPU in use (ADSP or Transputer).
'---------------------------------------------------------------
#IF PROZESSOR = T9 THEN
  #define DL         20400000h
  #define DH         20400010h
  #define DLX        20400020h
  #define DHX        20400030h
  #define ADWR       20400060h
  #define ADRD       20400070h
  #define CPU_EVENT  204000F0h
  #define WATCHDOG   204001D0h
  #define WD_TIMER   204001E0h
  #define CPU_LED    204001F0h
	#define D32        20400180h
#ELSE
	#IF PROZESSOR = T10 THEN
  	#define DL         20800000h
	  #define DH         20800010h
  	#define DLX        20800020h
	  #define DHX        20800030h
  	#define ADWR       20800060h
	  #define ADRD       20800070h
  	#define CPU_EVENT  208000F0h
	  #define WATCHDOG   208001D0h
  	#define WD_TIMER   208001E0h
	  #define CPU_LED    208001F0h
		#define D32        20800180h
	#ELSE
    #define DL               00h
    #define DH               10h
    #define DLX              20h
    #define DHX              30h
    #define ADWR             60h
    #define ADRD             70h
    #define CPU_EVENT       0F0h
    #define WATCHDOG        1D0h
    #define WD_TIMER        1E0h
    #define CPU_LED         1F0h
	#ENDIF
#ENDIF
'---------------------------------------------------------------
' Procedure which adds five NOP-instructions after a REG.-WRITE
' to compensate delaytimes.
'---------------------------------------------------------------
SUB poke_nop(adress,value)
#IF PROZESSOR = T9 THEN
   poke(adress,value)
   nops(5)   
#ELSE
	#IF PROZESSOR = T10 THEN
   poke(adress,value)
   nops(10)
	#ELSE
   poke(adress,value)
	#ENDIF
#ENDIF
ENDSUB


'---------------------------------------------------------------
' Procedure which adds one additional NOP-instruction only for
' the ADSP processor, because only neccessary there.
'---------------------------------------------------------------
SUB NOP_T9()
  #IF PROZESSOR = T9 THEN
    NOP
  #ENDIF
  #IF PROZESSOR = T10 THEN
    NOP
		NOP
  #ENDIF
ENDSUB


'---------------------------------------------------------------
' IF a low-priority process access a Pro-module it must not be
' interrupted by any other process !!!
'---------------------------------------------------------------
SUB SUB_BEGIN_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      BEGIN_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION()
  #IF PROZESSOR = ADSP THEN
    #IF PRIORITAET = LOW
      END_CRITICAL_SECTION
    #ENDIF
  #ENDIF
ENDSUB



'***********************' Convert the digitial value to an analog output
' card:   module-address
' DAC_No: channel number of analog output
' value:  output value (0..65535)
'***********************
SUB DAC(card,DAC_No,value)
  DIM addr, dac_n,out_value AS INTEGER
  out_value = value
  IF (out_value < 0) THEN out_value = 0
  IF (out_value > 0FFFFh) THEN out_value = 0FFFFh
  PRECALC
  dac_n = DAC_No-1
  PRECALC
  addr = (dac_n OR 080h) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,out_value)
  SUB_END_CRITICAL_SECTION
  PRECALC
  addr = 090h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Set DAC-register to desired value
' card:   module-address
' DAC_No: channel number of analog output
' value:  output value (0..65535)
'***************************************************************
SUB WRITEDAC(card,DAC_No,value)
  DIM addr, dac_n, out_value AS INTEGER
  out_value = value
  IF (out_value < 0) THEN out_value = 0
  IF (out_value > 0FFFFh) THEN out_value = 0FFFFh
  PRECALC
  dac_n = DAC_No-1
  PRECALC
  addr = (dac_n OR 080h) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,out_value)
  SUB_END_CRITICAL_SECTION
ENDSUB

' ***************************************************************
' Set DAC-register to desired value 
' card: module-address
' DAC_No: 0 = Channel 1 and 2
' DAC_No: 1 = Channel 3 and 4
' DAC_No: 2 = Channel 5 and 6
' DAC_No: 3 = Channel 7 and 8
' value: output value 32Bit
' only AOUT Rev B or C
'***************************************************************
SUB WRITEDAC32(card,DAC_N,value)
DIM addr, AS INTEGER
addr = ((dac_n) OR 0A0h) OR (SHIFT_LEFT(card,8))
SUB_BEGIN_CRITICAL_SECTION
POKE(ADWR,addr)
NOP_T9
Poke_NOP(d32,value)
SUB_END_CRITICAL_SECTION
ENDSUB


'***************************************************************
' Simultaneously start conversion of all DAC on this module.
' card:   module-address
'***************************************************************
SUB START_DAC(card)
  DIM addr, dac_n AS INTEGER
  PRECALC
  addr = 090h OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
  POKE(ADWR,addr)
  NOP_T9
  Poke_NOP(DLX,0)
  SUB_END_CRITICAL_SECTION
ENDSUB



'****************************************************************
' NEW COMMANDS FOR DAC Module with MEM option
'****************************************************************

'****************************************************************
' set the mode of the dac modul
' card:   module-address
' mode=0  normal mode 
' mode=1  frequency generator mode
' This sub is only for ADSP processors and AOUT with MEM option
'****************************************************************
SUB FG_MODE(card,mode)   
DIM adr as integer
  adr = (23 OR 080h) OR (SHIFT_LEFT(card,8))
  
	SUB_BEGIN_CRITICAL_SECTION
   poke(ADWR , adr )
   nop_t9
   poke_nop( DLX , 0)
	SUB_END_CRITICAL_SECTION

	SUB_BEGIN_CRITICAL_SECTION
   poke(ADWR , adr )
   nop_t9
   poke_nop( DLX , mode)
	SUB_END_CRITICAL_SECTION
ENDSUB

'****************************************************************
' set the delay between two steps
' card:   module-address
' DAC_No: channel number of analog output
' scale:  F_output=80 MHz/scale
' This sub is only for ADSP processors and AOUT with MEM option
'****************************************************************
SUB FG_DELAY(card, DAC_No, scale)   																 '														         
  DIM adr as integer
  adr = (10 OR 080h) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
    poke_nop( D32 ,(scale-2) or shift_left((DAC_no)-1,29))  
  SUB_END_CRITICAL_SECTION
EndSub	


'****************************************************************
' set the buffer of each channel
' card:   module-address
' DAC_No: channel number of analog output
' value_startadr: start_adr of memory
' value_ramsize: size of memory for this channel
' This sub is only for ADSP processors and AOUT with MEM option
'****************************************************************
SUB FG_DEF(card, DAC_No, value_startadr, value_ramsize)  
  DIM adr as integer
	
  adr = (8 OR 080h) OR (SHIFT_LEFT(card,8))
	
  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
    poke_nop( D32, (value_startadr) OR shift_left((DAC_no-1),29))  
 SUB_END_CRITICAL_SECTION
 
   inc adr

  SUB_BEGIN_CRITICAL_SECTION
    poke( ADWR, adr)
    nop_t9
    poke_nop( D32, (value_ramsize) OR shift_left((DAC_no-1),29))
  SUB_END_CRITICAL_SECTION
ENDSUB


'**************************************************************
'transfer the output data from a array to the memory of the dac card
'card : dip switch address
'ramstart_adr: start_adr of memory
'length: number of values (only even-numbered)
'array: source array 
'array_startindex: startindex in the source array
'This sub is only for ADSP processors and AOUT with MEM option
'**************************************************************
SUB FG_WRITE(card,ramstart_adr,length,array,array_startindex)

DIM ADR AS LONG
DIM value AS LONG
DIM i AS LONG
dim lenint as long
dim pointer as long
dim hw as long
dim lw as long

 ADR=(18 OR 080h) OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION
	  poke( ADWR, adr)
    nop_t9
   poke_nop(d32,((ramstart_adr) or (080000000H)) )
  SUB_END_CRITICAL_SECTION

	pointer=array_startindex
  inc adr 
 
 lenint=LENGTH 
 
 if (LENINT>1) then
   for i=1 to LENINT step 2   
   
	 lw=array[pointer] AND 0FFFFH
	 inc pointer
	 hw=shift_left(array[pointer],16)
	 inc pointer
	 value=lw or hw
	 
	  SUB_BEGIN_CRITICAL_SECTION 
      poke(ADWR,adr)
			nop_t9
      poke_nop(d32,value)
    SUB_END_CRITICAL_SECTION
   NEXT
 endif
 
ENDSUB

'**************************************************************
'transfer the waveform data from memory to an array
'card : dip switch address
'ramstart_adr:  start_adr of memory
'length: number of values (only even-numbered)
'array: destination array 
'array_startindex: startindex in the destination array
'This sub is only for ADSP processors and AOUT with MEM option
'**************************************************************
SUB FG_READ(card,ramstart_adr,length,array,array_startindex)

DIM ADR AS LONG
DIM value AS LONG
DIM i AS LONG
dim lenint as long
dim pointer as long
dim hw as long
dim lw as long

 ADR=(18 OR 080h) OR (SHIFT_LEFT(card,8))

  SUB_BEGIN_CRITICAL_SECTION
	  poke( ADWR, adr)
    nop_t9
    poke_nop( d32 , (ramstart_adr))
  SUB_END_CRITICAL_SECTION

	pointer=array_startindex
  inc adr 
 
 sleep(6)
 
 lenint=LENGTH 
 
 if (LENINT>1) then
   for i=1 to LENINT step 2   
	  SUB_BEGIN_CRITICAL_SECTION 
      poke_nop(ADRD,adr)
      value=peek(d32)
    SUB_END_CRITICAL_SECTION
	 
		 
	 array[pointer]=value AND 0FFFFH
	 inc pointer
	 array[pointer]=shift_right(value,16)
	 inc pointer
   NEXT
 endif
 
ENDSUB


'****************************************************************
' Reads the actual output-position of channel 1-8 in the RAM
' card : dip switch address
' DAC_No: channel number of analog output
' This sub is only for ADSP processors and AOUT with MEM option
''***************************************************************
FUNCTION FG_READ_INDEX(card, DAC_No) AS LONG
  DIM adr as integer
  adr = ((7+(DAC_No))  OR 080h) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    FG_READ_INDEX= peek(d32) and 01FFFFFh  
  SUB_END_CRITICAL_SECTION
	nop_t9
ENDFUNCTION


'****************************************************************
' START/STOP FREQUENCYGENERATOR
' card : dip switch address
' value : bitcombination ; each bit corresponds with an output
' action: action=0 starts output of Dacs immediately 
				 'action=1 stops output of Dacs immediately 
         'action=2 stops output of Dacs after the periode
' This sub is only for ADSP processors and AOUT with MEM option				 
''***************************************************************

SUB FG_CONTROL(card,value,action)   																	
  DIM adr as integer
  adr = ((20 OR 080h) OR (SHIFT_LEFT(card,8)))+action
  SUB_BEGIN_CRITICAL_SECTION
   poke(ADWR , adr )
   nop_t9
   poke_nop( DLX , (value) AND 0FFFFH )
  SUB_END_CRITICAL_SECTION
ENDSUB

'****************************************************************
' READ STATUS 
' card : dip switch address
' value : bitcombination ; each bit corresponds with an output
' value=1 generator of the channel is running
' value=0 generator of the channel is stopped
' This sub is only for ADSP processors and AOUT with MEM option
''***************************************************************

FUNCTION FG_STATUS(card) AS INTEGER
  DIM adr as integer
	adr = (20 OR 080h) OR (SHIFT_LEFT(card,8))
  SUB_BEGIN_CRITICAL_SECTION
    poke_nop(ADRD, adr )
    FG_STATUS= peek(DLX) and 0Fh  
  SUB_END_CRITICAL_SECTION
  nop_t9
ENDFUNCTION

#ENDIF
