# $Id: acinclude.m4,v 1.2 2004/07/21 16:16:08 cvs Exp $
# check the requested options
AC_DEFUN([ADWIN_LABVIEW_CONFIG], [
	AC_MSG_CHECKING([location of adwin libraries])
	if test "/etc/adwin/ADWINDIR"; then 
		ADWINDIR=`cat /etc/adwin/ADWINDIR`
		AC_MSG_RESULT([$ADWINDIR/lib])
	else
		AC_MSG_RESULT([not found])
		echo "Could not find ADwin library (libadwin.so)!"
		echo "Please install a recent version of adwin-lib."
		exit 1;
	fi

	AC_MSG_CHECKING(if link adwin32.dll exists)
	AC_ARG_ENABLE(adwin32,
	        AC_HELP_STRING([--disable-adwin32],
	                [do not create link from adwin32.dll to libadwin.so]),
	        [ create_adwin32_dll="no" ],
		[ create_adwin32_dll="yes" ]
	)
	if test ! -e /usr/lib/adwin32.dll ; then 
		if test "$create_adwin32_dll" = "yes"; then
	        	AC_MSG_RESULT([no - will be created])
		else
	        	AC_MSG_RESULT(no)
			echo "Link from /usr/lib/adwin32.dll to libadwin.so does"
			echo "not exist. Please create it by hand or pass option "
			echo "--enable-adwin32 to configure (preferred)."
			echo "Note: root access will be required for make install."
			exit 1;
		fi
	else # link exists, do nothing
        	AC_MSG_RESULT(yes)
		create_adwin32_dll="no"
	fi
	AM_CONDITIONAL([MAKE_LINK], [test "$create_adwin32_dll" = yes ])
])
